﻿<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8"/>
    <title></title>
</head>
<body>
<button onclick="loadJson()"> refresh </button>
<label for="offset">offset:</label>
<input type="text" id="offset" name="offset" value="0">
<label for="count">count</label>
<input type="text" id="count" name="count" value="100">
<label for="type">type</label>
<input type="text" id="type" name="type" value="1">

</body>
</html>

<script type="text/javascript">
    var _table_ = document.createElement('table'),
        _tr_ = document.createElement('tr'),
        _th_ = document.createElement('th'),
        _td_ = document.createElement('td');

    _table_.setAttribute("id", "_table");


    function loadJson() {
        var t = document.getElementById("_table");
        if (t) {
            document.getElementById("_table").remove();
            _table_ = document.createElement('table'),
                _tr_ = document.createElement('tr'),
                _th_ = document.createElement('th'),
                _td_ = document.createElement('td');
        }
        var count = document.getElementById('count').value;
        var offset = document.getElementById('offset').value;
        var type = document.getElementById('type').value;


        var params = `offset=${offset}&count=${count}&status=${type}`;


        _table_.setAttribute("id", "_table");
        var xmlhttp = new XMLHttpRequest();

        xmlhttp.open('GET', '/message/list' + '?' + params, true);

        xmlhttp.setRequestHeader("Content-Type", "application/json");

        xmlhttp.onreadystatechange = function() {
            if (xmlhttp.readyState === XMLHttpRequest.DONE) {
                if (xmlhttp.status === 200) {
                    document.body.appendChild(buildHtmlTable(JSON.parse(xmlhttp.responseText)));
                }
            }
        };
        xmlhttp.send(null);
    }


    function buildHtmlTable(arr) {
        var table = _table_.cloneNode(false),
            columns = addAllColumnHeaders(arr, table);
        for (var i = 0, maxi = arr.length; i < maxi; ++i) {
            var tr = _tr_.cloneNode(false);
            for (var j = 0, maxj = columns.length; j < maxj; ++j) {
                var td = _td_.cloneNode(false);
                cellValue = arr[i][columns[j]];
                td.appendChild(document.createTextNode(arr[i][columns[j]] || ''));
                tr.appendChild(td);
            }
            table.appendChild(tr);
        }
        return table;
    }


    function addAllColumnHeaders(arr, table) {
        var columnSet = [],
            tr = _tr_.cloneNode(false);
        for (var i = 0, l = arr.length; i < l; i++) {
            for (var key in arr[i]) {
                if (arr[i].hasOwnProperty(key) && columnSet.indexOf(key) === -1) {
                    columnSet.push(key);
                    var th = _th_.cloneNode(false);
                    th.appendChild(document.createTextNode(key));
                    tr.appendChild(th);
                }
            }
        }
        table.appendChild(tr);
        return columnSet;
    }

</script>